// FileInformation.cpp: Implementierung der Klasse CFileInformation.
//
//////////////////////////////////////////////////////////////////////



#include "stdafx.h"
#include "FileInformation.h"

#include <time.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

enum Attribute {
   normal =    0x00,
   readOnly =  0x01,
   hidden =    0x02,
   sys =    0x04,
   volume =    0x08,
   directory = 0x10,
   archive =   0x20
   };



//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CFileInformation::CFileInformation()
{
	memset(&fileStatus,0,sizeof(fileStatus));
}

CFileInformation::~CFileInformation()
{

}

bool CFileInformation::open(CString path,CString filename)
{
	if (!CFile::GetStatus(path,fileStatus))
	{
		TRACE1("Datei %s konnte nicht geladen werden\n",path);

		return false;
	}
	else
	{
		fileName = filename;
		fullPath = path;

		TRACE1("Datei %s konnte erfolgreich geladen werden\n",path);

		return true;
	}
}

void CFileInformation::setFilename(CString filename)
{
	fullPath.Replace(fileName,filename);
	CFile::Rename(fileStatus.m_szFullName,fullPath);

	strcpy(fileStatus.m_szFullName,fullPath.GetBuffer(0));
}

void CFileInformation::setReadOnly(bool yesNo)
{
	if (yesNo)
	{
		if (!getReadOnly())
		{
			fileStatus.m_attribute |= readOnly;
		}
	}
	else
	{
		if (getReadOnly())
		{
			fileStatus.m_attribute &= ~readOnly;
		}
	}
}

void CFileInformation::setHidden(bool yesNo)
{
	if (yesNo)
	{
		if (!getHidden())
		{
			fileStatus.m_attribute |= hidden;
		}
	}
	else
	{
		if (getHidden())
		{
			fileStatus.m_attribute &= ~hidden;
		}
	}
}

void CFileInformation::setSystem(bool yesNo)
{
	if (yesNo)
	{
		if (!getSystem())
		{
			fileStatus.m_attribute |= sys;
		}
	}
	else
	{
		if (getSystem())
		{
			fileStatus.m_attribute &= ~sys;
		}
	}
}

void CFileInformation::setArchive(bool yesNo)
{
	if (yesNo)
	{
		if (!getArchive())
		{
			fileStatus.m_attribute |= archive;
		}
	}
	else
	{
		if (getArchive())
		{
			fileStatus.m_attribute &= ~archive;
		}
	}
}

void CFileInformation::setCreationTime(CTime time)
{
	setModifyTime(CTime::GetCurrentTime());
	fileStatus.m_ctime = time;
}

void CFileInformation::setLastAccessTime(CTime time)
{
	setModifyTime(CTime::GetCurrentTime());
	fileStatus.m_atime = time;
}

void CFileInformation::setModifyTime(CTime time)
{
	fileStatus.m_mtime = time;
}

void CFileInformation::save()
{
	/*if (path.IsEmpty())
	{
		return;
	}**/

	try
	{
		CFile::SetStatus(fullPath,fileStatus);
	}
	catch (CFileException* error)
	{
		char string[256];
		
		error->GetErrorMessage(string,256);

		TRACE1("Exception wurde ausgelst: %s\n",string);

		error->Delete();

		return;
	}

	TRACE1("Datei %s gespeichert!!\n",fullPath);
}

bool CFileInformation::getArchive()
{
	return ((fileStatus.m_attribute & archive) == archive);
}

bool CFileInformation::getHidden()
{
	return ((fileStatus.m_attribute & hidden) == hidden);
}

bool CFileInformation::getReadOnly()
{
	return ((fileStatus.m_attribute & readOnly) == readOnly);
}

bool CFileInformation::getSystem()
{
	return ((fileStatus.m_attribute & sys) == sys);
}

CString CFileInformation::getFilename()
{
	return fileName;
}

CTime CFileInformation::getCreationTime()
{
	return fileStatus.m_ctime;
}

CTime CFileInformation::getLastAccessTime()
{
	return fileStatus.m_atime;
}

CTime CFileInformation::getModifyTime()
{
	return fileStatus.m_mtime;
}

int CFileInformation::getSize()
{
	if (fileStatus.m_size != 0)
	{
		return fileStatus.m_size;
	}

	return 000;
}

CString CFileInformation::getPath()
{
	CString returnValue;

	returnValue = fileStatus.m_szFullName;
	returnValue.Replace(fileName,"");
	
	return returnValue;
}
